grammar Gramatica;

prog: block EOF;


//funcion: func_declaration*;

block
 : stat*
 |
 func_declaration*
 ;

stat: 	
		impresion 		
	|	asignacion	
    |   declaracion
	|	condicion_if
    ;

func_declaration: type ID PARENTESIS_A param? PARENTESIS_C  bloque_llaves  ;

//params: param (','? param)* ;

param: type ID ;

    expr:	
		expr operacion = (MULTI|DIV) expr 	#MulDiv
	|	expr operacion = (SUMA|RESTA) expr 	#AddSub
	|	expr operacion=(MAYOR | MENOR | MAYOR_IGUAL | MENOR_IGUAL) expr #relationalExpr
	|  (INT | FLOAT) 					#int
	|   ID 									#id
	|	PARENTESIS_A expr PARENTESIS_C #Parentesiss
	;


impresion: 'print' PARENTESIS_A expr PARENTESIS_C ';';

asignacion: ID '=' expr ';' ;

declaracion: type ID  ';' ;

type: ENTERO | FLOAT;

condicion_if
 : IF bloque_condicion (ELSE IF bloque_condicion)* (ELSE bloque_llaves)?
 ;

bloque_condicion
 : expr bloque_llaves
 ;

bloque_llaves
 : LLAVE_A block LLAVE_C
 | stat
 ;


ciclo_while
 : WHILE expr bloque_llaves
 ;


FLOATANTE
 : [0-9]+ '.' [0-9]* 
 | '.' [0-9]+
 ;
SUMA 	: 	'+';
RESTA 	: 	'-';
MULTI 	: 	'*';
DIV 	: 	'/';
ENTERO 	:'int';
FLOAT 	:'float';
PARENTESIS_A:'(';
PARENTESIS_C:')';
MAYOR: '>';
MENOR: '<';
MAYOR_IGUAL: '>=';
IF		:'if';
ELSE: 'else';
WHILE: 'while';
MENOR_IGUAL: '<=';
IGUAL_IGUAL: '==';
LLAVE_A:'{';
LLAVE_C:'}';
ID 		:	[a-z]+;
INT 	:	[0-9]+;
FLOTANTE: DIGITO+'.' DIGITO*|'.' DIGITO+;
WS 		:	[ \t\n\r]+ -> skip;
fragment 
DIGITO: [0-9];