import org.antlr.v4.runtime.*;
import org.antlr.v4.runtime.tree.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
/*Para compilarse debido a que se aplican visitas aqui se compila de la siguiente manera
    antlr4 -no-listener -visitor Expr.g4(nombre de la gramatica)
    */
public class Main
{
    public static void main(String[] args) throws Exception 
    {
        /* Aqui hacemos la entrada de datos */
        ANTLRInputStream input;
        if(args.length !=0)
        {   input = new ANTLRInputStream(new BufferedReader(new FileReader(args[0])));  }
        else
        {   input = new ANTLRInputStream(System.in);    }

      /** Aqui creamos el analizador lexico */
      GramaticaLexer lexer = new GramaticaLexer(input);

      /** Aqui creamos los tokens*/
      CommonTokenStream tokens = new CommonTokenStream(lexer);

     /**Aqui se crea el analizador sintactico */
     GramaticaParser parser = new GramaticaParser(tokens);

     /** crear un arbol sintactico */
     ParseTree tree = parser.prog();

     /*Aqui creamos y utilizamos el walker dandole como parametro el arbol e implementando
        la clase Reconocedor que creamos la cual contiene los metodos SobreEscritos para
        realizar la funcion establecida en la misma clase dependiendo la regla a la que se
        acceda*/

     /* ParseTreeWalker walker = new ParseTreeWalker();
     walker.walk(new Reconocedor(),tree);
     System.out.println(); */
     
        /*Crear Visitas*/
      EvalVisitas visita = new EvalVisitas();
        visita.visit(tree);

    }
}