import java.util.List; // import just the List interface
import java.util.Arrays;
import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.InputStreamReader;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.antlr.v4.runtime.ANTLRFileStream;
import org.antlr.v4.runtime.ANTLRInputStream;
import org.antlr.v4.runtime.CommonTokenStream;
import org.antlr.v4.runtime.tree.ParseTree;
import org.antlr.v4.runtime.tree.ParseTreeWalker;
import org.antlr.v4.runtime.ParserRuleContext;


/**
 * Clase que permite cargar una ventana con un area de texto
 * y las opciones de abrir o guardar un archivo
 * @author HENAO
 *
 */
public class Ventana extends JFrame implements ActionListener 
	{
		private Container contenedor;
		JLabel labelTitulo;/*declaramos el objeto Label*/
		JLabel labelTituloResultado;
		JTextArea areaDeTexto;
		JTextArea resultadoTexto;
		JButton botonAbrir;/*declaramos el objeto Boton*/
		JButton botonGuardar;/*declaramos el objeto Boton*/
		JButton botonEjecutar;/*declaramos el objeto Boton*/
		JScrollPane scrollPaneArea;
		JScrollPane scrollPaneAreaResult;
		JFileChooser fileChooser; /*Declaramos el objeto fileChooser*/
		
		String texto;
		File archivo;
		String codigo;

		public Ventana() { //constructor		
		
			contenedor = getContentPane();
			contenedor.setBounds(0,0,800,600);
			contenedor.setLayout(null);
			
			/*Creamos el objeto*/
			fileChooser=new JFileChooser();
			
			/*Propiedades del Label, lo instanciamos, posicionamos y
			 * activamos los eventos*/
			labelTitulo= new JLabel();
			labelTitulo.setText("Editor de archvio");
			labelTitulo.setBounds(140, 20, 180, 23);

			labelTituloResultado= new JLabel();
			labelTituloResultado.setText("Resultado");
			labelTituloResultado.setBounds(560, 20, 180, 23);
			
			areaDeTexto = new JTextArea();
			//para que el texto se ajuste al area
			areaDeTexto.setLineWrap(true);
			//permite que no queden palabras incompletas al hacer el salto de linea
			areaDeTexto.setWrapStyleWord(true);
		   	scrollPaneArea = new JScrollPane();
			scrollPaneArea.setBounds(20, 50, 360, 270);
	        scrollPaneArea.setViewportView(areaDeTexto);

			//Area de texto que mostrara el resultado al ejecutar el programa
			resultadoTexto = new JTextArea();
			resultadoTexto.setLineWrap(true);
			resultadoTexto.setWrapStyleWord(true);
		   	scrollPaneAreaResult = new JScrollPane();
			scrollPaneAreaResult.setBounds(420, 50, 360, 270);
	        scrollPaneAreaResult.setViewportView(resultadoTexto);

			/*Propiedades del boton, lo instanciamos, posicionamos y
			 * activamos los eventos*/
			botonAbrir= new JButton();
			botonAbrir.setText("Abrir");
			botonAbrir.setBounds(20, 330, 106, 23);
			botonAbrir.addActionListener(this);
			
			botonGuardar= new JButton();
			botonGuardar.setText("Guardar");
			botonGuardar.setBounds(146, 330, 106, 23);
			botonGuardar.addActionListener(this);
			
			botonEjecutar= new JButton();
			botonEjecutar.setText("Ejecutar");
			botonEjecutar.setBounds(273, 330, 106, 23);
			botonEjecutar.addActionListener(this);
			
			/*Agregamos los componentes al Contenedor*/
			contenedor.add(labelTitulo);
			contenedor.add(labelTituloResultado);
			contenedor.add(scrollPaneArea);
			contenedor.add(scrollPaneAreaResult);
			contenedor.add(botonAbrir);
			contenedor.add(botonGuardar);
			contenedor.add(botonEjecutar);
       		//Asigna un titulo a la barra de titulo
			setTitle("Compilador");
			//tamaño de la ventana
			setSize(800,400);
			//pone la ventana en el Centro de la pantalla
			setLocationRelativeTo(null);

	        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}

		@Override
		public void actionPerformed(ActionEvent evento) {

			if(evento.getSource() == botonAbrir) {
				String archivo=abrirArchivo();
				areaDeTexto.setText(archivo);
			} else if (evento.getSource() == botonGuardar) {
				guardarArchivo();
			} else {
				//ejecutar();
			}

		}

		/**
		 * Permite mostrar la ventana que carga 
		 * archivos en el area de texto
		 * @return
		 */
		private String abrirArchivo() {
					
			String aux=""; 		
	 		texto="";
		
	 		try
			{
	 			/*llamamos el metodo que permite cargar la ventana*/
	    		fileChooser.showOpenDialog(this);
	    		/*abrimos el archivo seleccionado*/
	 			archivo = fileChooser.getSelectedFile();

	 			/*recorremos el archivo, lo leemos para plasmarlo
	 			 *en el area de texto*/
	 			if(archivo != null)
	 			{ 				
	 				FileReader archivos=new FileReader(archivo);
	 				BufferedReader lee=new BufferedReader(archivos);
	 				while((aux=lee.readLine())!=null)
	 					{
	 					 texto+= aux+ "\n";
	 					}

	 		  		lee.close();
	 			} 			
	 		}
	 		catch(IOException ex)
			{
			  JOptionPane.showMessageDialog(null,ex+"" +
			  		"\nNo se ha encontrado el archivo",
			  		"ADVERTENCIA!!!",JOptionPane.WARNING_MESSAGE);
			}
				return texto;
		}
		
		/**
		 * Guardamos el archivo del area 
		 * de texto en el equipo
		 */
		private void guardarArchivo() {
			if(archivo == null) {
				guardarNuevoArchivo();
			} else {
				try{
					FileWriter escribir = new FileWriter(archivo);
					BufferedWriter bw = new BufferedWriter(escribir);
					PrintWriter wr = new PrintWriter(bw);
					wr.write(areaDeTexto.getText());
					wr.close();
					bw.close();
				}catch(IOException e){
					e.printStackTrace();
				};
			}
		}
		//private void ejecutar() {
		/*	String codigo = "";
			if(archivo == null) {
				System.out.print(areaDeTexto.getText());
				JOptionPane.showMessageDialog(null,"Selecciona un archivo","Error",JOptionPane.INFORMATION_MESSAGE);
			}
			else {
				// Compila
				try {
					ANTLRFileStream afs = new ANTLRFileStream(archivo.getAbsolutePath()); //Cargamos el archivo
					compiladorLexer lexer = new compiladorLexer(afs); //Intanciamos un lexer
					CommonTokenStream tokens = new CommonTokenStream(lexer);
					compiladorParser parser = new compiladorParser(tokens);
					Mylistener listener = new Mylistener();
					parser.setBuildParseTree(false);
					ParseTree tree = parser.file();
					codigo = listener.getContent(parser.file());
					// listener.visitFieldContains(parser.file());
					// System.out.print("asdsad -> "+ sourceTextForContext(parser.file));/
					// List<String> ruleNames = Arrays.asList(parser.getRuleNames());
					// for(int i = 0; i < ruleNames.size(); i++) {
					// 	System.out.println(ruleNames.get(i));
					// }
					ParseTreeWalker walker = new ParseTreeWalker(); // create standard walker
                    compiladorBaseListener extractor = new compiladorBaseListener();
					extractor.enterImprimir(parser.imprimir());
                    walker.walk(extractor, tree); // initiate walk of tree with listener

					//////////////////////// Ejecutando comandos con processBuilder ////////////////////////
					// ProcessBuilder pb = new ProcessBuilder("show.sh");
					
					// // new ProcessBuilder("antlr4", "Gramatica.g4","-no-listener -visitor").start();
					// // new ProcessBuilder("javac", "Main.java").start();
					// // new ProcessBuilder("cd","../../Desktop/eje24/compilador*.java").start();
					
					// Process process = pb.start();

					// // blocked :(
					// BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()));

					// String line;
					// while ((line = reader.readLine()) != null) {
					// 	System.out.println(line);
					// }

					// int exitCode = process.waitFor();
					// System.out.println("\nExited with error code : " + exitCode);
					//////////////////////////////////////////////////////////////////////////////////////////


					/////////////////////// prueba con script ///////////////////////
					// ProcessBuilder pb = new ProcessBuilder("./run.sh");
					// Process p = pb.start();
					// BufferedReader reader = new BufferedReader(new InputStreamReader(p.getInputStream()));
					// String line = null;
					// while ((line = reader.readLine()) != null)
					// {
					// 	System.out.println(line);
					// }
					////////////////////////////////////////////////////////////////

				} catch (Exception e1) {
					e1.printStackTrace();
				}
				resultadoTexto.setText(codigo);
			}
		}

		// private String sourceTextForContext(ParseTree context) {
		// 	Token startToken = (context.start instanceof TerminalNode) ? (TerminalNode)(start).getSymbol() : (ParserRuleContext)(start).start;
		// 	Token stopToken = (context.stop instanceof TerminalNode) ? (TerminalNode)(stop).getSymbol() : (ParserRuleContext)(stop).start;

		// 	CharStream cs = start.getTokenSource().getInputStream();
		// 	int stopIndex = stop != null ? stop.getStopIndex() : -1;
		// 	return cs.getText(new Interval(start.getStartIndex(), stopIndex));
		// }

		/**
		 * Guardamos el archivo del area 
		 * de texto en el equipo
		 */
		private void guardarNuevoArchivo() {

	 		try
	 		{
				String nombre="";
				JFileChooser file=new JFileChooser();
				file.showSaveDialog(this);
				File guarda = file.getSelectedFile();
		
				if(guarda !=null)
				{
		 			nombre=file.getSelectedFile().getName();
		 			/*guardamos el archivo y le damos el formato directamente,
		 			 * si queremos que se guarde en formato doc lo definimos como .doc*/
		 			FileWriter  save=new FileWriter(guarda+".txt");
		 			save.write(areaDeTexto.getText());
		 			save.close();
		 			JOptionPane.showMessageDialog(null,
		 					"El archivo se a guardado Exitosamente",
		 					"Información",JOptionPane.INFORMATION_MESSAGE);
			    }
	 		 }
	 	   catch(IOException ex)
		   {
			 JOptionPane.showMessageDialog(null,
					 "Su archivo no se ha guardado",
					 "Advertencia",JOptionPane.WARNING_MESSAGE);
		   }
		}

        public static void main(String[] args) {
			Ventana miVentana = new Ventana();
			miVentana.setVisible(true);
		}
	}